import os, sys, traceback

# Import of sorts
old_init = __init__
__init__ = False
execfile('slides.py')
__init__ = old_init

from compgeo import extents
import sdl_doc
from collections import defaultdict
# inp = {"type": "Will", "count": 1}
test_inputs = [{'type': 'Si', 'req': 2, 'cap': 4}, {'type': 'Will', 'req': 1, 'cap': 2}]
test_outputs = [{'type': 'Building', 'prod': 1}]
test_inputs = [{'type': 'Will', 'req': 2, 'cap': 4}]
test_outputs = [{'type': 'Si', 'prod': 1, 'cap': 4}]
test_outputs = [{'type': 'Will', 'prod': 2, 'cap': 4}]

font_size = 20
fg_color = [1, 1, 1]
bg_color = [0.05, 0.05, 0.05]
PIPE_WIDTH = 3
GAME_FREQUENCY = 100
spacing = 10
debug = False

def n(inp):
    return tree_lang.parse(inp, locals=globals())

def rectangle5(topleft, bottomright):
    return rectangle1({"value": topleft}, {"value": bottomright})

def make_blue():
    for ref in doc['selection']:
        ref['ref']['stroke_color'] = (0.5, 0.5, 1)

#del converters[max(converters.keys())]

#add_converter([{'type': 'Will', 'req': 1, , outputs)

def add_converter(inputs, outputs, duration=4, pos=P(0, 0), type_="converter", dummy=False):
    # Completion is actually conv_start!
    parent = doc[doc['selection.root'] if not dummy else 'toolbox']
    #parent = doc[doc['selection.root']]
    parent.append(Node("group",
      type=type_,
      completion=None,
      duration=duration,
      ellapsed=exc('None if `self.completion is None else min(`game.tick - `self.completion, `self.duration)'),
      percent=exc('0 if `self.completion is None else float(`self.ellapsed) / `self.duration'),
    ))
      #,fill_color=bg_color,
      #stroke_color=fg_color))
    root = parent.L[-1]
    padding = P(spacing * 2, spacing * 2)
    inp_bboxes = [P(*extents('9/9 ' + inp['type'], 20, 'RoboMono')[1]) + padding
                  for inp in inputs]
    out_bboxes = [P(*extents('9(+9) ' + out['type'], 20, 'RoboMono')[1]) + padding
                  for out in outputs]
    height = max(numpy.sum(inp_bboxes, axis=0)[1],
                 numpy.sum(out_bboxes, axis=0)[1])
    inp_height = inp_bboxes[0][1]
    count_box = P(*extents('9/9 ', 20, 'RoboMono')[1])
    inp_width = numpy.max(inp_bboxes, axis=0)[0]
    out_width = numpy.max(out_bboxes, axis=0)[0]
    root.append(Node("group", child_id="inputs",
      children=[Node("group", transforms={"align": ("translate", P(0, i * inp_height))},
                     fill_color=bg_color,
                     index=i,
                     count=0,
                     diff=0,
                     children=[
          rectangle5(P(0, 0), P(inp_width, inp_height)),
          Node("text", value=exr('"%s/%s" % (`self.parent.count, `self.parent.req)'),
               p_botleft=P(spacing, inp_height - spacing)),
          Node("text", value=exr('`self.parent.type'), font_face='RoboMono',
               p_botleft=P(spacing + count_box[0], inp_height - spacing))], **inp)
          for i, inp in enumerate(inputs)]))
    root.append(Node("group", child_id="outputs",
      children=[Node("group",
                     fill_color=bg_color,
                     index=i,
                     count=0,
                     diff=0,
                     transforms={"align": ("translate",
                                           P(inp_width, i * inp_height))},
                     children=[
          rectangle5(P(0, 0), P(out_width, inp_height)),
          Node("text", value=exr('`self.parent.type'), font_face='RoboMono',
               p_botleft=P(spacing, inp_height - spacing)),
          Node("text", value=exr('"%s(+%s)" % (`self.parent.count, `self.parent.prod)'),
               p_botleft=P(out_width - count_box[0] - spacing, inp_height - spacing)),
], **out)
          for i, out in enumerate(outputs)]))
    root.append(Node("group", child_id="progress", skip_points=False,
                     transform=("translate", P(0, height + spacing)),
      children=[Node("line", child_id="line", line_width=PIPE_WIDTH,
                     skip_points=True,
                     stroke_color=(0.8, 0.8, 1),
                     p_start=P(3 * inp_width / 4, 0),
                     p_end=P(inp_width + out_width / 4, 0)),
                Node("point", child_id="marker", value=P(0, 0), icon="res_icon",
                     visible=exr('`self.parent.parent.completion is not None'))
                     ]))
    root.L['progress.marker.value'] =\
      exr('`self.parent.line.start.value * (1 - `self.parent.parent.percent) +'
          '`self.parent.line.end.value * `self.parent.parent.percent')
    # stroke_color=(0, 0, 1),
    root.multi_insert(0, [rectangle5(*root.L.bbox())])
    root.transforms['singleton'] = ("translate", pos)
    if dummy:
        return root
    converters[root['id']] = Converter(root)
    return converters[root['id']]

def midpoint(node):
    return numpy.sum(node.bbox(node.combined_transform(stop=doc['main_layer'])), axis=0) / 2

def add_pipe(start, end, duration=4, type_="pipe", sxy=None, exy=None):
    doc[doc['selection.root']].append(Node("group",
      type=type_,
      completion=None,
      duration=duration,
      ellapsed=exc('None if `self.completion is None else min(`game.tick - `self.completion, `self.duration)'),
      percent=exc('0 if `self.completion is None else float(`self.ellapsed) / `self.duration'),
      start_id=start['id'],
      end_id=end['id'],
    ))
    root = doc[doc['selection.root']][-1]
    #inputs = [{key:start[key] for key in ['prod', 'type']
    #           if key in start}]
    #outputs = [{key:end[key] for key in ['prod', 'type']
    #            if key in end}]
    #inputs[0].update({'cap': 1, 'req': 1, 'count': 0, 'diff': 0})
    #outputs[0].update({'cap': 1, 'prod': 1, 'count': 0, 'diff': 0})
    inputs = [{'cap': 1, 'req': 1, 'count': 0, 'diff': 0, 'type': start['type']}]
    outputs = [{'cap': 1, 'prod': 1, 'count': 0, 'diff': 0, 'type': end['type']}]
    #print "in, out", inputs, outputs
    root.append(Node("group", child_id="inputs",
      children=[Node("group", index=i, **inp) for i, inp in enumerate(inputs)]))
    root.append(Node("group", child_id="outputs",
      children=[Node("group", index=i, **out) for i, out in enumerate(outputs)]))
    if sxy is not None:
        root.append(Node("group", child_id="progress", skip_points=False,
          children=[Node("line", child_id="line", line_width=PIPE_WIDTH,
                         skip_points=True,
                         stroke_color=(0.8, 0.8, 1),
                         p_start = sxy,
                         p_end = exy,),
                    Node("point", child_id="marker", value=P(0, 0), icon="res_icon",
                         visible=exr('`self.parent.parent.completion is not None'))
                         ]))
    else:
        root.append(Node("group", child_id="progress", skip_points=False,
          children=[Node("line", child_id="line", line_width=PIPE_WIDTH,
                         skip_points=True,
                         stroke_color=(0.8, 0.8, 1),
                         px_start = exc('midpoint(`%s)' % start['id']),
                         px_end = exc('midpoint(`%s)' % end['id'])),
                    Node("point", child_id="marker", value=P(0, 0), icon="res_icon",
                         visible=exr('`self.parent.parent.completion is not None'))
                         ]))
    root.L['progress.marker.value'] =\
      exr('`self.parent.line.start.value * (1 - `self.parent.parent.percent) +'
          '`self.parent.line.end.value * `self.parent.parent.percent')
    converters[root['id']] = Converter(root)
    if sxy is None:
        doc['main_layer.edges'][start['id']] = root.L['inputs.0.id']
        doc['main_layer.edges'][root.L['outputs.0.id']] = end['id']
    #doc['main_layer.pipes'][start['id']] = end['id']
    #print doc['main_layer.edges']
    #doc['main_layer.edges'][(start['id'], start['index'])] = (root['id'], 0)
    #doc['main_layer.edges'][(root['id'], 0)] = (end['id'], end['index'])
    return converters[root['id']]

def add_pipeline(start, end):
    doc[doc['selection.root']].append(
        Node("line",
             px_start = exr('numpy.sum((`%s).bbox((`%s).combined_transform()), axis=0) / 2' % (start['id'], start['id'])),
             px_end = exr('numpy.sum((`%s).bbox((`%s).combined_transform()), axis=0) / 2' % (end['id'], end['id']))))

class Converter():
    def __init__(self, root):
        self.root = root
        for inp in self.r['inputs']:
            inp.L['count'] = 0
            inp.L['diff'] = 0
        for out in self.r['outputs']:
            out.L['count'] = 0
            out.L['diff'] = 0

    @property
    def r(self):
        return self.root.L

    def update_diffs(self):
        for inp in self.r['inputs']:
            inp.L['count'] = inp['count'] + inp['diff']
            inp.L['diff'] = 0

    def input_met(self):
        return all(inp['count'] >= inp['req'] for inp in self.r['inputs'])

    def test_fill(self):
        for inp in self.r['inputs']:
            inp['count'] += inp['req']

    def tick(self):
        if self.r['completion'] is not None:
            if doc['game.tick'] - self.r['completion'] >= self.r['duration']:
                if all(out.get('cap') is None or\
                       out['count'] + out['prod'] <= out['cap']
                       for out in self.r['outputs']):
                    for out in self.r['outputs']:
                        out['count'] += out['prod']
                        # Should round here?
                    self.r['completion'] = None
        if self.r['completion'] is None and self.input_met():
            for inp in self.r['inputs']:
                inp.L['diff'] -= inp.L['req']
            self.r['completion'] = doc['game.tick']
            if self.r['outputs.0.type'] == "Building":
                #any(out['type'] == 'Building' for out in self.r['outputs']):
                self.disconnect_pipes()
                self.r['removed'] = True
                conv = add_converter(self.r['outputs.0.building_inputs'],
                                     self.r['outputs.0.building_outputs'])
                for k in self.r.transforms.order:
                    conv.r.transforms[k] = self.r.transforms[k]
            elif self.r['outputs.0.type'].startswith("Research"):
                name = short_names[self.r['outputs.0.type'][len("Research "):]]
                #name = self.r['res_name']
                doc['game.completed'].append(name)
                self.disconnect_pipes()
                self.r['removed'] = True

    def disconnect_pipes(self):
        rev_pipes = {v:[] for v in doc['main_layer.edges'].values()}
        for k, v in doc['main_layer.edges'].items():
            rev_pipes[v].append(k)
        #rev_pipes = {v:k for k, v in doc['main_layer.edges'].items()}
        for inp in self.r['inputs']:
            if inp['id'] in rev_pipes:
                for id_ in rev_pipes[inp['id']]:
                    node = doc[id_]
                    conv = node.parent.parent
                    assert(conv.parent['id'] == 'main_layer')
                    #conv.parent.remove(conv)
                    conv.deparent()

    def __repr__(self):
        inp_str = ", ".join("%s: %s/%s" % (inp['type'], inp['count'], inp['req'])
                            for inp in self.r['inputs'])
        out_str = ", ".join("%s: %s (+%s)" % (out['type'], out['count'], out['prod'])
                            for out in self.r['outputs'])
        return "%s  -- %s/%s ->  %s" % (inp_str, self.r['ellapsed'],
                                        self.r['duration'], out_str)

class ConverterGroup(object):
    def __init__(self, root_id):
        self.root_id = root_id

    @property
    def r(self):
        return doc[self.root_id]

    @property
    def converters(self):
        for child in self:
            if child.type == "converter":
                yield child

    def tick(self):
        for child in self.r:
            if child.get('type') in ['converter', 'pipe']:
                converters[child['id']].tick()
        for child in list(self.r):
            if child.get('removed'):
                self.r.remove(child)
        #for (start, i), (end, j) in self.r['edges'].items():
        for start, end in self.r['edges'].items():                
            if start not in doc or end not in doc:
                print "Missing nodes, deleting edge", start, end
                del self.r['edges'][start]
                continue
            # Not quite right...I guess output need diffs too.
            #inp = (self.r[end] if end in self.r else doc[end])['inputs'][j]
            #out = (self.r[start] if start in self.r else doc[start])['outputs'][i]
            # Will be a problem for duplication
            out = doc[start]
            inp = doc[end]
            diff = out['count'] if inp.get('cap') is None else\
                   min(out['count'], inp['cap'] - (inp['count'] + inp['diff']))
            inp['diff'] += diff
            out.L['count'] -= diff
        for child in self.r:
            if child.get('type') in ['converter', 'pipe']:
                converters[child['id']].update_diffs()

    def __repr__(self):
        return "\n".join("%s: %s" % (child['id'], converters[child['id']])
                         for child in self.r)

def setup_test():
    add_converter(test_inputs, test_outputs)
    add_converter(test_inputs, test_outputs)
    id1, id2 = converters.keys()
    doc[id2]['transforms.singleton'] = ("translate", P(10, 100))
    #pipe = add_pipe(doc[id1]['outputs.0'], doc[id2]['inputs.0'])
    #id1, id2, id3 = sorted(converters.keys())
    #doc['main_layer.edges'][(id1, 0)] = (pipe.r['id'], 0)
    #doc['main_layer.edges'][(pipe.r['id'], 0)] = (id2, 0)

def setup_test():
    c1 = add_converter_str("Will 1/2 --> Si 1/2")
    c2 = add_converter_str("Will 1/2 --> Si 1/2", pos=P(0, 300))
    add_pipe(c1.r['outputs.0'], c2.r['inputs.0'])

def setup_test():
    for i in range(10):
        add_converter_str("Will 1/2 --> Will 1/2", pos=P(0, 200+80*i))
        #add_converter_str("Will 1/2 --> Si 1/2", pos=P(0, 200+80*i))

short_names = {'Manual Si Shapers': 'res_shaper',
               'Energy Redirection': 'en',
               'Si Gathering Automation': 'auto_si',
               'Powered Shaper': 'res_power_shaper',
               'Energy Concentrator': 'res_sh_en',
               'Faster Si Gathering': 'res_fast_si',
               'Direct Flow Control': 'res_flow',
               'Flow Shaper': 'res_flow_shaper',
}

conditions = {'refine': lambda total: total['Si'] >= 2,
              'structure': lambda total: total['ShSi'] >= 2,
              'hoard': lambda total: total['ShSi'] >= 10 or total['Si'] >= 10}

def fill_void():
    for child in doc['main_layer']:
        if child.get('type') in ['converter', 'pipe']:
            for elem in child['inputs']:
                if elem['type'] == "Void" and (elem["cap"] is None or\
                                               elem["count"] + elem["diff"] < elem["cap"]):
                    elem['diff'] += 1

def game_tick():
    doc['game.tick'] += 1
    cg.tick()
    if doc['game.tick'] % 10 == 0:
        fill_void()
        # Check completions and rewards
        total_ = total()
        for task in doc['game.tasks']:
            if task in conditions and conditions[task](total_):
                doc['game.completed'].append(task)
        while doc['game.completed']:
            task = doc['game.completed'].pop()
            if task in doc['game.tasks']:
                doc['game.tasks'].remove(task)
                reward(task)

def start_pipe(node):
    if node['id'] in doc['main_layer.edges']:
        pipe = doc[doc['main_layer.edges'][node['id']]].parent.parent
        # Ugly hack!
        try:
            pipe.deparent()
        except:
            pass
    pipe = Node("line", ref=node['id'], p_start=midpoint(node),
                p_end=doc["editor.mouse_txy"])
    doc["main_layer"].append(pipe)
    doc["editor.drag_start"] = doc["editor.mouse_txy"]
    doc["editor.grabbed"] = pipe[1]["id"]
    pipe[1].transforms["editor"] = exr("('translate', `editor.mouse_txy - `editor.drag_start)")

def add_pipe_start():
    root = doc[doc["selection.root"]]
    txy = doc["editor.mouse_xy"]
    for child in root:
        if child.get('type') == 'converter':
            for out in child['outputs']:
                if out['type'] != "Building" and\
                   not out['type'].startswith("Research") and\
                   collide(out, txy, transform=out.combined_transform()):
                    print "Pipe start collision"
                    start_pipe(out)
                    return True
    return False

def add_pipe_end():
    root = doc[doc["selection.root"]]
    txy = doc["editor.mouse_xy"]
    print "pipe end"
    node = doc[doc["editor.grabbed"]]
    out = doc[node.parent['ref']]
    for child in root:
        if child.get('type') == 'converter':
            for inp in child['inputs']:
                if out['type'] == inp['type'] and\
                   collide(inp, txy, transform=inp.combined_transform()):
                    #node.parent.parent.remove(node.parent)
                    node.parent.deparent()
                    add_pipe(out, inp)
                    doc["editor.drag_start"] = None
                    doc["editor.grabbed"] = None
                    return True
    return False

def cancel_pipe():
    node = doc[doc["editor.grabbed"]]
    node.parent.deparent()

def start_build():
    #conv = add_converter(test_inputs, test_outputs)
    inputs = [{'type': 'Will', 'req': 2, 'cap': 2}]
    #outputs = [{'type': 'Building', 'prod': 1, 'cap': 1}]
    outputs = [{'type': 'Building', 'prod': 1, 'cap': 1,
                'building_inputs': [{'type': 'Will', 'req': 2, 'cap': 2}],
                'building_outputs': [{'type': 'Si', 'prod': 2, 'cap': 2}]}]
    inputs = [{'type': 'Si', 'req': 2, 'cap': 2}]
    outputs = [{'type': 'Si', 'prod': 2, 'cap': 2}]
    conv = add_converter(inputs, outputs)
    conv.r.transforms["editor"] = exc("('translate', `editor.mouse_xy)")
    doc['editor.grabbed'] = conv.r['id']

def mode(s):
    return doc['editor.mode'] == s

def build(desc):
    conv = add_converter_str(desc)
    conv.r.transforms["editor"] = exc("('translate', `editor.mouse_txy)")
    doc['editor.grabbed'] = conv.r['id']

def build_button():
    root = doc['toolbox']
    xy = doc["editor.mouse_xy"]
    for child in reversed(root):
        if collide(child, xy, transform=child.combined_transform()):
            print "clicked on tool", child["id"], "on_click" in child
            if "on_click" in child:
                run_text(child["id"], "on_click")
                if child["on_click"] == "doc.save()":
                    return False
            return True
    return False

def cancel_build():
    if doc['editor.grabbed'] is not None:
        doc[doc['editor.grabbed']].deparent()
    #node.parent.remove(node)
    
def drop_build():
    node = doc[doc['editor.grabbed']]
    if "move" not in node.transforms:
        node.transforms["move"] = ("translate", P(0, 0))
    new = node.L["transforms.move"][1] + node.L["transforms.editor"][1]
    node.L.transforms["move"] = ("translate", new)
    del node.L.transforms["editor"]
    doc["editor.grabbed"] = None

def add_will():
    root = doc[doc["selection.root"]]
    txy = doc["editor.mouse_xy"]
    for child in root:
        if child.get('type') == 'converter':
            for gc in child['inputs']:
                if gc['type'] == 'Will' and collide(gc, txy, transform=gc.combined_transform()):
                    #print "Add will"
                    # Add animation?
                    if gc.get('cap') is None or gc['count'] + gc['diff'] < gc['cap']:
                        gc['diff'] += 1
                    return True
    return False

def parse_converter_str(s):
    inputstr, outputstr = s.split("-->")
    def parse(s, req_name="req"):
        type_, req_cap = s.strip().rsplit(' ', 1)
        req, cap = map(int, req_cap.split("/"))
        return {"type": type_, req_name: req, "cap": cap}
    inputs = [parse(elem) for elem in inputstr.strip().split(",")]
    outputs = [parse(elem, "prod") for elem in outputstr.strip().split(",")]
    return inputs, outputs

def test_parse_converter_str():
    s = "Will 1/2 --> Si 1/2"
    s = "Will 2/2, Si 1/1 --> Building 1/1"
    print parse_converter_str(s)

def add_converter_str(s, **kwargs):
    return add_converter(*parse_converter_str(s), **kwargs)

pdocument.scope['numpy'] = numpy
pdocument.scope['midpoint'] = midpoint

# Game tick loop
from uielem import uidict

def game_tick_wrapper(timer, delay):
    global game_run
    try:
        game_tick()
    except:
        doc.last_tb = sys.exc_traceback
        traceback.print_exc()
        game_run = False
    if delay is not None and game_run:
        timer.after(delay, game_tick_wrapper, timer, delay)

def reset_globals():
    global converters, cg
    print "Reset globals"
    converters = {}
    cg = ConverterGroup('main_layer')
    doc['main_layer.edges'] = {}

def start_timer():
    global game_run
    print "Starting timer"
    game_run = True
    uidict["root"].after(10, game_tick_wrapper, uidict["root"], GAME_FREQUENCY)

def message(lines):
    #lines = text.split("\n")
    lines = lines + [""] * (3 - len(lines))
    for line, node in zip(lines, doc['message']):
        node['value'] = line

def total():
    count = defaultdict(int)
    for child in doc['main_layer']:
        if child.get('type') in ['converter', 'pipe']:
            for elem in child['outputs']:
                if elem['type'] != "Building" and\
                   not elem['type'].startswith("Research"):
                   count[elem['type']] += elem['count']
    return count

def remove_res(name):
    if name in doc['toolbox']:
        doc['toolbox'].remove(doc['toolbox'][name])
        del doc['toolbox'][name]

def reward(name):
    if name == "start":
        message(["Destruction. Oblivion. Urgency does not stop time and it passes.",
                 "As always, luck strikes and I can exert my will.",
                 "[w-click on 'Will' by moving the mouse over 'Will' and press 'w'.]"])
        for child in list(doc['main_layer']):
            child.deparent()
        reset_globals()
        doc['game.new_game'] = False
        doc['toolbox.visible'] = True
        doc['toolbox_bg.visible'] = True
        doc['message.visible'] = True
        add_converter_str("Will 2/4 --> Si 1/2", pos=P(30, 300))
    elif name == "refine":
        message(["The material gathered is too unrefined. But without energy,",
                 "I will have to find another way to give it structure.",
                 "[I can now research Manual Si Shapers. Click on it in the toolbox and click anywhere.]"])
        add_building_str("Will 4/4 --> Research Manual Si Shapers 1/1",
                         name="res_shaper")
    elif name == "res_shaper": # Manual Si Shapers
        remove_res("res_shaper")
        message(["I can use my will to shape the material. But it will take some time. [I can now build",
                 "Manual Si Shapers.] To supply it with Si, I will add a pipeline.",
                 "[p-click the source and then p-click the destination. Press esc to cancel.]"]) #  ('Si' made from 'Will')
        add_building_str("Si 2/4, Will 4/8 --> ShSi 1/4")
    elif name == "structure":
        message([])
        add_building_str("ShSi 4/4 --> Research Si Gathering Automation 1/1",
                         name="res_auto_si")
        add_building_str("ShSi 4/4 --> Research Energy Redirection 1/1",
                         name="res_en")
    elif name == "auto_si":
        remove_res("res_auto_si")
        add_building_str("Void 4/4 --> Si 1/2")
    elif name == "en":
        remove_res("res_en")
        message(["There is order other than my own. A rough translation:",
                 '"Its heading right for ***! There\'s no time to evacuate everyone there."',
                 '"We have to think of something..."'])
        add_building_str("ShSi 2/4 --> J 1/2")
        add_building_str("J 3/3 --> Research Powered Shaper 1/1",
                         name="res_power_shaper")
        add_building_str("J 3/3 --> Research Energy Concentrator 1/1",
                         name="res_sh_en")
    elif name == "res_power_shaper":
        message(["More translated order:",
                 '"Today, we\'re gathered to celebrate the defeat of **** and commemorate',
                 'the heros\' sacrifice."'])
        remove_res("res_power_shaper")
        add_building_str("Si 8/16, J 1/2 --> ShSi 4/8")
    elif name == "res_sh_en":
        message(['More translation: "I knew the scientists would doom us all! I just hope no-one',
                 'touched my ship."',
                 'This message has a familarity to it. Was this me?'])
        remove_res("res_sh_en")
        add_building_str("J 2/4, ShSi 4/8 --> ShJ 1/2")
        add_building_str("ShJ 2/2 --> Research Faster Si Gathering 1/1",
                         name="res_fast_si")
        add_building_str("ShJ 2/2 --> Research Direct Flow Control 1/1",
                         name="res_flow")
    elif name == "res_fast_si":
        remove_res("res_fast_si")
        add_building_str("Void 2/2 --> Si 1/2")
    elif name == "res_flow":
        add_building_str("ShJ 2/4, ShSi 2/4 --> Flow 1/2")
        add_building_str("Flow 2/2 --> Research Flow Shaper 1/1",
                         name="res_flow_shaper")
    elif name == "res_flow_shaper":
        message(["I am suddenly attacked by an annoying unfinished game message:",
                 '"That\'s all there is for now. At least the bugs didn\'t stop anyone from reaching this point."'])
        add_building_str("Flow 1/2 --> Flux 1/2")
    elif name == "hoard":
        add_building_str("Si 1/1 --> Si 1/20")
        add_building_str("ShSi 1/1 --> ShSi 1/20")
    else:
        raise Exception("Unknown reward: %s" % name)

def add_building_str(s, name=None):
    pos = P(spacing + doc['toolbox.-1'].bbox()[1][0], 10)
    conv = add_converter_str(s, pos=pos, dummy=True)
    conv.L.transforms['iconify'] = ("scale", P(0.5, 0.5))
    conv.L['on_click'] = "build(%s)" % repr(s)
    if name:
        doc['toolbox'][name] = exr('`%s' % conv.L['id'])
        conv.L['res_name'] = name

def complete_task():
    for task in list(doc['game.tasks']):
        if condition[task]():
            doc['game.tasks'].remove(task)

def scroll_toolbox(side):
    if not collide(doc["toolbox_bg"], doc['editor.mouse_xy']):
        return False
    xy = get_translate(doc['toolbox'], "scroll_xy") + int(side) * P(50, 0)
    doc['toolbox.transforms.scroll_xy'] = ("translate", xy)
    return True

def add_title_pipe():
    from math import sin, cos, pi
    c = P(400, 300)
    sides = 5
    r = 150
    positions = [c - r * P(sin(2*i*2*pi / sides), cos(2*i*2*pi / sides))
                 for i in range(sides-1,-1,-1)]
    convs = []
    for i, pos in enumerate(positions):
        convs.append(add_pipe({"type": "circ", "id": i},
                              {"type": "circ", "id": i+1},
                              duration=6,
                              sxy=pos,
                              exy=positions[(i+1) % len(positions)]))
    for i, conv in enumerate(convs):
        nconv = convs[(i+1) % len(convs)]
        doc['main_layer.edges'][conv.r['outputs.0.id']] = nconv.r['inputs.0.id']
    convs[0].r['inputs.0.diff'] = 1
    doc['main_layer'].append(Node("text", value="Start", p_botleft=c + P(-36, 13),
                                  on_click="reward('start')"))
    doc['toolbox.visible'] = False
    doc['toolbox_bg.visible'] = False
    doc['message.visible'] = False

def load_converters():
    # reset_globals()
    for child in doc['main_layer']:
        if child.get('type') in ['converter', 'pipe']:
            converters[child['id']] = Converter(child)
    for child in doc['main_layer']:
        if child.get('type') in ['pipe']:
            doc['main_layer.edges'][child['start_id']] = child.L['inputs.0.id']
            doc['main_layer.edges'][child.L['outputs.0.id']] = child['end_id']

def quit():
    uidict["root"].quit()

if __init__:
    sdl_doc.font_files = {'RoboMono': os.path.join(*"fonts/RobotoMono-Medium.ttf".split("/")),
                          None: os.path.join(*"fonts/OpenSans-Bold.ttf".split("/"))}
    doc['drawing'].extend(n("""
    group:
      group: id="custom_ui" visible=True
      group: id="main_layer"
    """))
    doc['selection.root'] = 'main_layer'
    doc['editor.window_width'], doc['editor.window_height'] = 800, 600
    doc['editor.filename'] = 'pyweek26_doc.py'
    #doc['root'].append(Node("group", id='animations'))
    #doc['root'].append(Node("group", id="timer", paused=True, total=0))
    doc.saved = [doc.m]
    doc.undo_index = -1
    doc['overlay.transforms'] = exr('`drawing.transforms')
    doc.sync()
    doc.load()
    doc['editor.slide'] = 'main_layer'

    doc.surface.layers.clear()
    doc.surface.addlayer(doc, "background")
    doc.surface.addlayer(doc, "drawing")
    doc.surface.addlayer(doc, "ui")
    reset_globals()
    start_timer()
    uidict["root"].withdraw()
    if doc['game.new_game']:
        doc['game.tasks'] = conditions.keys()
        doc['game.tasks'].extend(short_names.values())
        add_title_pipe()
        #reward('start')
    else:
        load_converters()
    if not debug:
        doc['drawing.skip_points'] = True
        doc['toolbox.skip_points'] = True
        doc['custom_ui.visible'] = False

input_callbacks += """
empty_selection = key_press(escape) !empty_selection !cancel_build
profile_start = key_press(d) ?ended_profiler !profile_start
profile_end   = key_press(d) !profile_end

add_pipe = key_press(p) ?add_pipe_start
           (~(key_press(escape) !cancel_pipe | key_press(p) ?add_pipe_end)
            @anything)*
build = key_press(b) !start_build
        (~key_press(b) ~key_press(escape) @anything)* 
        (key_press(escape) !cancel_build | key_press(b) !drop_build)
add_will = key_press(w) ?add_will
build_button = mouse_press(1) ?build_button
        (~mouse_press(1) ~key_press(escape) @anything)* 
        (key_press(escape) !cancel_build | mouse_press(1) !drop_build mouse_release(1))
scroll_toolbox = mouse_press(4) ?scroll_toolbox(1)
               | mouse_press(5) ?scroll_toolbox(-1)
quit = key_press(q) !quit

game_command = @add_pipe | @scroll_toolbox | @build | @add_will | @build_button
             | @quit | @command
game_command_strict = @add_pipe | @scroll_toolbox | @build | @add_will | @build_button
                    | @zoom | @scroll | @select | @delete | @move_selection
grammar = (@game_command !save_undo | @anything)*
"""
